
#include "GyverWDT.h"                                 // Watchdog (WDT), сторожевой таймер
#include <Encoder.h>

Encoder Enc(3, A0);
long Position       = 0;

#define SB_Enc        2
#define Clear         7
#define Water         8
#define Red_Led      A1
#define Beep          4
#define Led13        13
byte Flag_B         = 0;
byte Flag_D         = 0;

int  Period         = 0;
byte Int_SB         = 0;

#define BEEP    digitalWrite(Beep, HIGH); delay(100); digitalWrite(Beep, LOW);
/*=======================================================================================================
                                            Прерывание по SB_Enc
=======================================================================================================*/
void Int_SB_Enc()
{
  while (digitalRead(SB_Enc) == 0);
  Int_SB = 1;
}
/*=======================================================================================================
                                            Инициализация
=======================================================================================================*/
void setup()
{
  Serial.begin(115200);
  
  Watchdog.enable(RESET_MODE, WDT_PRESCALER_256);       // Режим сторжевого сброса, таймаут ~2 сек

  pinMode(Beep, OUTPUT);
  BEEP
  pinMode(Led13, OUTPUT);
  digitalWrite(Led13, LOW);
  pinMode(SB_Enc, INPUT);
  pinMode(Clear, OUTPUT);
  digitalWrite(Clear, LOW);
  pinMode(Water, OUTPUT);
  digitalWrite(Water, LOW);
  pinMode(Red_Led, OUTPUT);
  digitalWrite(Red_Led, LOW);
  
  Serial.println(" << DVORNIK V 1.0 >> "); 
  
  attachInterrupt(0, Int_SB_Enc, FALLING);                // (D2) Вход 
}
/*=======================================================================================================
                                              Главный цикл
=======================================================================================================*/
void loop()
{
  Watchdog.reset();                                       // Переодический сброс WDT, если устройство работает
  Encoder();
  
  for (int i = Period; i >= 2; i--)                       // Определяем время задержки
  {
    Encoder();
    delay(30);
    Watchdog.reset();                                     // Переодический сброс WDT, если устройство работает
    if (Int_SB == 1) {Read_SB_Enc(); Int_SB = 0;}         // Отрабатываем нажатие кнопки по прерыванию
  }
  if (Int_SB == 1) {Read_SB_Enc(); Int_SB = 0;}           // Отрабатываем нажатие кнопки по прерыванию
/*-----------------------------------------------------------------------------------------------------*/
  if (Position >= 1)
  {
    digitalWrite(Led13, HIGH);
    digitalWrite(Red_Led, HIGH);
    digitalWrite(Clear, HIGH);                            // Включили дворники
    delay(500);                                           // Пауза перед выключением дворников
    Watchdog.reset();                                     // Переодический сброс WDT, если устройство работает
    digitalWrite(Led13, LOW);
    digitalWrite(Clear, LOW);                             // Выключили дворники
    digitalWrite(Red_Led, LOW);
  }
  delay(10);
}
/*=======================================================================================================
                                            Автоматическая очистка стекла
=======================================================================================================*/
void Read_SB_Enc()
{
  digitalWrite(Red_Led, HIGH);
  digitalWrite(Water, HIGH);                              // Включаем воду
  delay(1000);
  Watchdog.reset();                                       // Переодический сброс WDT, если устройство работает
  digitalWrite(Clear, HIGH);                              // Включаем дворники
  delay(1000);
  Watchdog.reset();                                       // Переодический сброс WDT, если устройство работает
  delay(1000);
  digitalWrite(Water, LOW);                               // Выключаем воду
  delay(1000);
  Watchdog.reset();                                       // Переодический сброс WDT, если устройство работает
  delay(1000);
  digitalWrite(Clear, LOW);                               // Выключаем дворники
  digitalWrite(Red_Led, LOW);
}
/*=======================================================================================================
                                              Encoder
=======================================================================================================*/
void Encoder()
{
  Position = Enc.read() * 2;
  if (Position >= 4) Flag_B = 0;
  if (Position <= 2) 
  {
    Position = 0;
    if (Flag_B == 0) {BEEP Flag_B = 1;}
  }
  Period = Position;
}
/*=====================================================================================================*/
